#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/errno.h>
#include <strings.h>

#ifdef DEBUG
#define dprintf printf
#else
#define dprintf if (0) printf
#endif


key_t ftok_check (char *name, int index)
{
  key_t temp;

  dprintf ("checking \'%s\',%d...", name, index);
  temp = ftok (name, index);
  if (temp == (key_t) - 1)
    {
      dprintf ("error %d, %s\n", errno, strerror (errno));
      exit (1);
    }
  dprintf ("key value %0qx\n", temp);
  return temp;
}

int
main (void)
{
  if (ftok_check ("./ftok", 1) == ftok_check ("./ftok", 2))
    {
      dprintf
	("ftok is broken, returned the same key for two different id's on the same file\n");
      return 1;
    }
  ftok_check ("./ftok.o", 1);
  ftok_check ("./ftok.o", 2);
  dprintf ("IPC_PRIVATE    = %0qx\n", IPC_PRIVATE);

  return 0;
}
