#include <sys/types.h>
#include <sys/shm.h>
#include <strings.h>
#include <errno.h>
#include <stdio.h>

#ifdef DEBUG
#define dprintf printf
#else
#define dprintf if (0) printf
#endif

int
main (void)
{
  key_t mykey;
  int shmid;
  char *testch = NULL;

  mykey = IPC_PRIVATE;

  dprintf ("creating private key... ");
  shmid = shmget (mykey, 65536, 0777);
  if (shmid != -1)
    {
      dprintf ("id %x\n", shmid);
      dprintf ("attaching... ");
      testch = (char *) shmat (shmid, NULL, 0);
      if (testch == (char *) -1)
	{
	  dprintf ("error %d, %s\n", errno, strerror (errno));
	  /* todo: delete the shm area */
	  return 1;
	}
      dprintf ("mapped to %x\n", testch);
      dprintf ("writing \'hello\' ...\n");
      snprintf (testch, 6, "hello");
      dprintf ("reading ... ");
      dprintf ("'%s'\n", testch);
    }
  else
    {
      dprintf ("error %d, %s\n", errno, strerror (errno));
      return 1;
    }

  return 0;
}
