#include <sys/types.h>
#include <sys/shm.h>
#include <strings.h>
#include <errno.h>

/* Test shmctl IPC_SET.
 * FIXME: low priority for now 
 * todo: reuse the previously stored to disk private shm id
 */

#ifdef DEBUG
#define dprintf printf
#else
#define dprintf if (0) printf
#endif

int
main (void)
{
  key_t mykey;
  int shmid, shmid1;
  struct shmid_ds shmds;
  mykey = IPC_PRIVATE;

  dprintf ("creating private key... ");
  shmid = shmget (mykey, 65536, 0777);
  if (shmid != -1)
  {dprintf ("id %0x\n", shmid);}
  else
    {
      dprintf ("failed\nerror %d, %s\n", errno, strerror (errno));
      return 1;
    }
  dprintf ("creating 2nd private key... ");
  shmid1 = shmget (mykey, 65536, 0777);
  if (shmid1 == shmid)
    {
      dprintf ("failed - duplicate id\n");
      return 1;
    }
  else if (shmid != -1)
  {dprintf ("id %0x\n", shmid1);}
  else
    {
      dprintf ("failed\nerror %d, %s\n", errno, strerror (errno));
      return 1;
    }
  dprintf ("Getting shmid_ds for shmid %0x...",shmid);
  if (shmctl (shmid, IPC_STAT, &shmds))
    {
      dprintf ("failed\nerror %d, %s\n", errno, strerror (errno));
      return 1;
    }
  else if (shmds.shm_segsz != 65536 ||
	shmds.shm_nattch != 0 /* also check perms */)
    {
      dprintf ("failed, returned data not consistent with our requested memory area\n");
      return 1;
    }
  else
  {dprintf("ok\n");}
    

  return 0;
}
