#include <sys/types.h>
#include <sys/shm.h>
#include <strings.h>
#include <errno.h>

/* This leaks the shmids. I know. 
 * Test that shmget works with a private key.
 * TODO: write the id to a file, so that it can
 * be cleaned up later in the testsuite
 */

#ifdef DEBUG
#define dprintf printf
#else
#define dprintf if (0) printf
#endif

int
main (void)
{
  key_t mykey;
  int shmid, shmid1;
  mykey = IPC_PRIVATE;

  dprintf ("creating private key... ");
  shmid = shmget (mykey, 65536, 0777);
  if (shmid != -1) {
      dprintf ("id %x\n", shmid);}
  else
    {
      dprintf ("failed\nerror %d, %s\n", errno, strerror (errno));
      return 1;
    }
  dprintf ("creating 2nd private key... ");
  shmid1 = shmget (mykey, 65536, 0777);
  if (shmid1 == shmid)
    {
      dprintf ("failed - duplicate id\n");
      return 1;
    }
  else if (shmid != -1) {
      dprintf ("id %x\n", shmid1);}
  else
    {
      dprintf ("failed\nerror %d, %s\n", errno, strerror (errno));
      return 1;
    }

  return 0;
}
